Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5213)
@@ -1819,10 +3751,10 @@
       
       ! Argument      
-      TYPE(TFILE), INTENT(IN) :: td_coord0
-      TYPE(TFILE), INTENT(IN) :: td_coord1
-      INTEGER(i4), INTENT(IN) :: id_imin0
-      INTEGER(i4), INTENT(IN) :: id_imax0
-      INTEGER(i4), INTENT(IN) :: id_jmin0
-      INTEGER(i4), INTENT(IN) :: id_jmax0
+      TYPE(TMPP)               , INTENT(IN) :: td_coord0
+      TYPE(TMPP)               , INTENT(IN) :: td_coord1
+      INTEGER(i4)              , INTENT(IN) :: id_imin0
+      INTEGER(i4)              , INTENT(IN) :: id_imax0
+      INTEGER(i4)              , INTENT(IN) :: id_jmin0
+      INTEGER(i4)              , INTENT(IN) :: id_jmax0
       INTEGER(i4), DIMENSION(:), INTENT(IN) :: id_rho
 
@@ -1852,7 +3784,4 @@
       REAL(dp)    :: dl_lat1p
 
-      REAL(dp)    :: dl_dlon
-      REAL(dp)    :: dl_dlat
-
       LOGICAL     :: ll_coincidence
 
@@ -1862,7 +3791,6 @@
       TYPE(TVAR)  :: tl_lat1
 
-      TYPE(TFILE) :: tl_coord0
-
-      TYPE(TMPP)  :: tl_mppcoord0
+      TYPE(TMPP)  :: tl_coord0
+      TYPE(TMPP)  :: tl_coord1
 
       TYPE(TDOM)  :: tl_dom0
@@ -1875,42 +3803,41 @@
       ll_coincidence=.TRUE.
 
-      ! read coarse longitue and latitude on domain
-      tl_coord0=td_coord0
-      CALL iom_open(tl_coord0)
-
-      !2-1 compute domain
+      ! copy structure
+      tl_coord0=mpp_copy(td_coord0)
+
+      ! compute domain
       tl_dom0=dom_init( tl_coord0,         &
       &                 id_imin0, id_imax0,&
       &                 id_jmin0, id_jmax0 )
 
-      !2-2 close file
-      CALL iom_close(tl_coord0)
-
-      !2-3 read variables on domain (ugly way to do it, have to work on it)
-      !2-3-1 init mpp structure
-      tl_mppcoord0=mpp_init(tl_coord0)
-
-      CALL file_clean(tl_coord0)
-
-      !2-3-2 get processor to be used
-      CALL mpp_get_use( tl_mppcoord0, tl_dom0 )
-
-      !2-3-3 open mpp files
-      CALL iom_mpp_open(tl_mppcoord0)
-
-      !2-3-4 read variable value on domain
-      tl_lon0=iom_mpp_read_var(tl_mppcoord0,'longitude',td_dom=tl_dom0)
-      tl_lat0=iom_mpp_read_var(tl_mppcoord0,'latitude' ,td_dom=tl_dom0)
-
-      !2-3-5 close mpp files
-      CALL iom_mpp_close(tl_mppcoord0)
-
-      !2-3-6 clean structure
-      CALL mpp_clean(tl_mppcoord0)
+      ! open mpp files
+      CALL iom_dom_open(tl_coord0, tl_dom0)
+
+      ! read variable value on domain
+      tl_lon0=iom_dom_read_var(tl_coord0,'longitude',tl_dom0)
+      tl_lat0=iom_dom_read_var(tl_coord0,'latitude' ,tl_dom0)
+
+      ! close mpp files
+      CALL iom_dom_close(tl_coord0)
+
+      ! clean structure
+      CALL mpp_clean(tl_coord0)
+      CALL dom_clean(tl_dom0)
+
+      ! copy structure
+      tl_coord1=mpp_copy(td_coord1)
+
+      ! open mpp files
+      CALL iom_mpp_open(tl_coord1)
 
       ! read fine longitue and latitude
-      tl_lon1=iom_read_var(td_coord1,'longitude')
-      tl_lat1=iom_read_var(td_coord1,'latitude')
+      tl_lon1=iom_mpp_read_var(tl_coord1,'longitude')
+      tl_lat1=iom_mpp_read_var(tl_coord1,'latitude')
       
+      ! close mpp files
+      CALL iom_dom_close(tl_coord1)
+      ! clean structure
+      CALL mpp_clean(tl_coord1)
+
       CALL logger_debug("GRID CHECK COINCIDENCE:"//&
       &        " fine   grid "//TRIM(td_coord1%c_name) )
@@ -1918,6 +3845,6 @@
       &        " coarse grid "//TRIM(td_coord0%c_name) )
 
-      !1- check domain
-      !1-1 check global grid
+      ! check domain
+      ! check global grid
       IF( .NOT. grid_is_global(tl_lon0, tl_lat0) )THEN
          IF( grid_is_global(tl_lon1, tl_lat1) )THEN
@@ -1929,7 +3856,7 @@
 
          ELSE
-            !1-2 ew overlap
             il_ew1=tl_lon1%i_ew
             IF( il_ew1 >= 0 )THEN
+               ! ew overlap
 
                il_ew0=tl_lon0%i_ew
@@ -1940,19 +3867,18 @@
                ENDIF
 
-               il_jmin1=1+ig_ghost
-               il_jmax1=tl_lon1%t_dim(2)%i_len-ig_ghost
+               il_jmin1=1+ip_ghost
+               il_jmax1=tl_lon1%t_dim(2)%i_len-ip_ghost
 
                ll_coincidence=grid__check_lat(&
                &                     tl_lat0%d_value(1,:,1,1),&
-               &                     tl_lat1%d_value(1,il_jmin1:il_jmax1,1,1),&
-               &                     id_rho(jp_J) )
+               &                     tl_lat1%d_value(1,il_jmin1:il_jmax1,1,1))
 
             ELSE
-               !1-3 other case
-               il_imin1=1+ig_ghost
-               il_jmin1=1+ig_ghost
-
-               il_imax1=tl_lon1%t_dim(1)%i_len-ig_ghost
-               il_jmax1=tl_lon1%t_dim(2)%i_len-ig_ghost
+               ! other case
+               il_imin1=1+ip_ghost
+               il_jmin1=1+ip_ghost
+
+               il_imax1=tl_lon1%t_dim(1)%i_len-ip_ghost
+               il_jmax1=tl_lon1%t_dim(2)%i_len-ip_ghost
 
                ll_coincidence=grid__check_corner(&
@@ -1967,5 +3893,5 @@
 
             ENDIF
-            
+ 
          ENDIF
 
@@ -1977,9 +3903,9 @@
       ENDIF
  
-      !2- check refinement factor
+      ! check refinement factor
       ! select point in middle of fine grid
       il_imid1=INT(tl_lon1%t_dim(1)%i_len*0.5)
       il_jmid1=INT(tl_lon1%t_dim(2)%i_len*0.5)
-      
+ 
       dl_lon1=tl_lon1%d_value(il_imid1, il_jmid1,1,1)
       dl_lat1=tl_lat1%d_value(il_imid1, il_jmid1,1,1)
@@ -2000,5 +3926,5 @@
       ! look for closest fine grid point from selected coarse grid point
       il_iind(:)=MAXLOC( tl_lon1%d_value(:,:,1,1), &
-      &                  tl_lon1%d_value(:,:,1,1) <= dl_lon0)
+      &                  tl_lon1%d_value(:,:,1,1) <= dl_lon0 )
 
       il_jind(:)=MAXLOC( tl_lat1%d_value(:,:,1,1), &
@@ -2016,12 +3942,8 @@
       dl_lat1=tl_lat1%d_value(il_indF(1),il_indF(2),1,1)
 
-      !2-1 check i-direction refinement factor
+      ! check i-direction refinement factor
       DO ji=1,MIN(3,il_imid1)
 
          IF( il_indF(1)+ji*id_rho(jp_I)+1 > tl_lon1%t_dim(1)%i_len )THEN
-            CALL logger_debug("GRID CHECK COINCIDENCE: tl_lon1%t_dim(1)%i_len "//TRIM(fct_str(tl_lon1%t_dim(1)%i_len)))
-            CALL logger_debug("GRID CHECK COINCIDENCE: il_indF(1)+ji*id_rhoi+1 "//TRIM(fct_str(il_indF(1)+ji*id_rho(jp_I)+1)))
-            CALL logger_debug("GRID CHECK COINCIDENCE: il_indF(1) "//TRIM(fct_str(il_indF(1))))
-            CALL logger_debug("GRID CHECK COINCIDENCE: id_rhoi "//TRIM(fct_str(id_rho(jp_I))))
             CALL logger_warn("GRID CHECK COINCIDENCE: domain to small "//&
             &  " to check i-direction refinement factor ")
@@ -2032,6 +3954,4 @@
 
             dl_lon1p=tl_lon1%d_value(il_indF(1)+ji*id_rho(jp_I)+1,il_indF(2),1,1)
-
-            dl_dlon=ABS(dl_lon1p-dl_lon1)*1.e-3
 
             SELECT CASE(MOD(id_rho(jp_I),2))
@@ -2049,5 +3969,5 @@
             CASE DEFAULT         
             
-               IF( ABS(dl_lon1 - dl_lon0) > dl_dlon )THEN
+               IF( ABS(dl_lon1 - dl_lon0) > dp_delta )THEN
                   ll_coincidence=.FALSE.
                   CALL logger_debug("GRID CHECK COINCIDENCE: invalid "//&
@@ -2062,5 +3982,5 @@
       ENDDO
 
-      !2-2 check j-direction refinement factor
+      ! check j-direction refinement factor
       DO jj=1,MIN(3,il_jmid1)
 
@@ -2074,6 +3994,4 @@
 
             dl_lat1p=tl_lat1%d_value(il_indF(1),il_indF(2)+jj*id_rho(jp_J)+1,1,1)
-
-            dl_dlat=ABS(dl_lat1p-dl_lat1)*1.e-3
 
             SELECT CASE(MOD(id_rho(jp_J),2))
@@ -2091,5 +4009,5 @@
             CASE DEFAULT
 
-               IF( ABS(dl_lat1-dl_lat0) > dl_dlat )THEN
+               IF( ABS(dl_lat1-dl_lat0) > dp_delta )THEN
                   ll_coincidence=.FALSE.
                   CALL logger_debug("GRID CHECK COINCIDENCE: invalid "//&
@@ -2104,4 +4022,10 @@
       ENDDO
 
+      ! clean 
+      CALL var_clean(tl_lon1)
+      CALL var_clean(tl_lat1)
+      CALL var_clean(tl_lon0)
+      CALL var_clean(tl_lat0)
+
       IF( .NOT. ll_coincidence )THEN
          CALL logger_fatal("GRID CHECK COINCIDENCE: no coincidence "//&
@@ -2111,5 +4035,4 @@
 
    END SUBROUTINE grid_check_coincidence
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function check that fine grid is 
@@ -2118,17 +4041,13 @@
    !> @details
    !> 
-   !> @note deltalon and delatlat are used only to avoid issue due to 
-   !> cubic interpolation approximation on the firsts grid points  
-   !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_lon0 : table of coarse grid longitude
-   !> @param[in] dd_lat0 : table of coarse grid latitude
-   !> @param[in] dd_lon1 : table of fine   grid longitude 
-   !> @param[in] dd_lat1 : table of fine   grid latitude
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] dd_lon0   array of coarse grid longitude
+   !> @param[in] dd_lat0   array of coarse grid latitude
+   !> @param[in] dd_lon1   array of fine   grid longitude 
+   !> @param[in] dd_lat1   array of fine   grid latitude
    !> @return logical, fine grid is inside coarse grid
    !-------------------------------------------------------------------
-   !> @code
    FUNCTION grid__check_corner(dd_lon0, dd_lat0, &
    &                           dd_lon1, dd_lat1 )
@@ -2162,7 +4081,4 @@
       REAL(dp)    :: dl_lon1
       REAL(dp)    :: dl_lat1
-
-      REAL(dp)    :: dl_dlon
-      REAL(dp)    :: dl_dlat
       ! loop indices
       !----------------------------------------------------------------
@@ -2182,15 +4098,13 @@
 
       ! check lower left corner
-      dl_lon0 = dd_lon0(il_imin0, il_jmin0  )
-      dl_lat0 = dd_lat0(il_imin0, il_jmin0  )
+      dl_lon0 = dd_lon0(il_imin0, il_jmin0)
+      dl_lat0 = dd_lat0(il_imin0, il_jmin0)
 
       dl_lon1 = dd_lon1(il_imin1, il_jmin1)
       dl_lat1 = dd_lat1(il_imin1, il_jmin1)
 
-      dl_dlon=ABS(dd_lon1(il_imin1+1,il_jmin1  )-dl_lon1)*1.e-3
-      dl_dlat=ABS(dd_lat1(il_imin1  ,il_jmin1+1)-dl_lat1)*1.e-3
-
-      IF( (ABS(dl_lon1-dl_lon0)>dl_dlon) .AND. (dl_lon1 < dl_lon0 ) .OR. & 
-      &   (ABS(dl_lat1-dl_lat0)>dl_dlat) .AND. (dl_lat1 < dl_lat0 ) )THEN
+
+      IF( (ABS(dl_lon1-dl_lon0)>dp_delta) .AND. (dl_lon1 < dl_lon0 ) .OR. & 
+      &   (ABS(dl_lat1-dl_lat0)>dp_delta) .AND. (dl_lat1 < dl_lat0 ) )THEN
 
          CALL logger_error("GRID CHECK COINCIDENCE: fine grid lower left "//&
@@ -2207,15 +4121,13 @@
 
       ! check upper left corner
-      dl_lon0 = dd_lon0(il_imin0, il_jmax0  )
-      dl_lat0 = dd_lat0(il_imin0, il_jmax0  )
+      dl_lon0 = dd_lon0(il_imin0, il_jmax0)
+      dl_lat0 = dd_lat0(il_imin0, il_jmax0)
 
       dl_lon1 = dd_lon1(il_imin1, il_jmax1)
       dl_lat1 = dd_lat1(il_imin1, il_jmax1)
 
-      dl_dlon=ABS(dd_lon1(il_imin1+1,il_jmax1  )-dl_lon1)*1.e-3
-      dl_dlat=ABS(dd_lat1(il_imin1  ,il_jmax1-1)-dl_lat1)*1.e-3
-
-      IF( (ABS(dl_lon1-dl_lon0)>dl_dlon) .AND. (dl_lon1 < dl_lon0) .OR. &
-      &   (ABS(dl_lat1-dl_lat0)>dl_dlat) .AND. (dl_lat1 > dl_lat0) )THEN
+
+      IF( (ABS(dl_lon1-dl_lon0)>dp_delta) .AND. (dl_lon1 < dl_lon0) .OR. &
+      &   (ABS(dl_lat1-dl_lat0)>dp_delta) .AND. (dl_lat1 > dl_lat0) )THEN
 
          CALL logger_error("GRID CHECK COINCIDENCE: fine grid upper left "//&
@@ -2232,18 +4144,16 @@
 
       ! check lower right corner
-      dl_lon0 = dd_lon0(il_imax0, il_jmin0  )
-      dl_lat0 = dd_lat0(il_imax0, il_jmin0  )
+      dl_lon0 = dd_lon0(il_imax0, il_jmin0)
+      dl_lat0 = dd_lat0(il_imax0, il_jmin0)
 
       dl_lon1 = dd_lon1(il_imax1, il_jmin1)
       dl_lat1 = dd_lat1(il_imax1, il_jmin1)
 
-      dl_dlon=ABS(dd_lon1(il_imax1-1,il_jmin1  )-dl_lon1)*1.e-3
-      dl_dlat=ABS(dd_lat1(il_imax1  ,il_jmin1+1)-dl_lat1)*1.e-3
-
-      IF( (ABS(dl_lon1-dl_lon0)>dl_dlon) .AND. (dl_lon1 > dl_lon0) .OR. &
-      &   (ABS(dl_lat1-dl_lat0)>dl_dlat) .AND. (dl_lat1 < dl_lat0) )THEN
+
+      IF( (ABS(dl_lon1-dl_lon0)>dp_delta) .AND. (dl_lon1 > dl_lon0) .OR. &
+      &   (ABS(dl_lat1-dl_lat0)>dp_delta) .AND. (dl_lat1 < dl_lat0) )THEN
 
          CALL logger_error("GRID CHECK COINCIDENCE: fine grid lower right "//&
-         &     "corner not north west west of coarse grid (imax,jmin) ")
+         &     "corner not north west of coarse grid (imax,jmin) ")
          CALL logger_debug(" fine   grid lower right ( "//&
          &              TRIM(fct_str(dl_lon1))//","//&
@@ -2257,15 +4167,12 @@
 
       ! check upper right corner
-      dl_lon0 = dd_lon0(il_imax0, il_jmax0  )
-      dl_lat0 = dd_lat0(il_imax0, il_jmax0  )
+      dl_lon0 = dd_lon0(il_imax0, il_jmax0)
+      dl_lat0 = dd_lat0(il_imax0, il_jmax0)
 
       dl_lon1 = dd_lon1(il_imax1, il_jmax1)
       dl_lat1 = dd_lat1(il_imax1, il_jmax1)
 
-      dl_dlon=ABS(dd_lon1(il_imax1-1,il_jmax1  )-dl_lon1)*1.e-3
-      dl_dlat=ABS(dd_lat1(il_imax1  ,il_jmax1-1)-dl_lat1)*1.e-3
-
-      IF( (ABS(dl_lon1-dl_lon0)>dl_dlon) .AND. (dl_lon1 > dl_lon0) .OR. &
-      &   (ABS(dl_lat1-dl_lat0)>dl_dlat) .AND. (dl_lat1 > dl_lat0) )THEN
+      IF( (ABS(dl_lon1-dl_lon0)>dp_delta) .AND. (dl_lon1 > dl_lon0) .OR. &
+      &   (ABS(dl_lat1-dl_lat0)>dp_delta) .AND. (dl_lat1 > dl_lat0) )THEN
 
          CALL logger_error("GRID CHECK COINCIDENCE: fine grid upper right "//&
@@ -2288,5 +4195,4 @@
 
    END FUNCTION grid__check_corner
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function check that fine grid latitude are 
@@ -2296,16 +4202,14 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_lat0 : table of coarse grid latitude 
-   !> @param[in] dd_lat1 : table of fine grid latitude 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid__check_lat(dd_lat0, dd_lat1, id_rhoj)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] dd_lat0   array of coarse grid latitude 
+   !> @param[in] dd_lat1   array of fine grid latitude 
+   !-------------------------------------------------------------------
+   FUNCTION grid__check_lat(dd_lat0, dd_lat1)
       IMPLICIT NONE
       ! Argument 
       REAL(dp), DIMENSION(:), INTENT(IN) :: dd_lat0
       REAL(dp), DIMENSION(:), INTENT(IN) :: dd_lat1
-      INTEGER(i4)           , INTENT(IN) :: id_rhoj
 
       ! function
@@ -2321,6 +4225,4 @@
       INTEGER(i4) :: il_jmin1
       INTEGER(i4) :: il_jmax1
-
-      REAL(dp)    :: dl_dlat
       ! loop indices
       !----------------------------------------------------------------
@@ -2333,12 +4235,9 @@
 
       !1- check if fine grid inside coarse grid domain
-      il_jmin0=1+1 ; il_jmax0=il_shape0(1)-1
-
-      il_jmin1=1+id_rhoj ; il_jmax1=il_shape1(1)-id_rhoj
-
-      dl_dlat=ABS(dd_lat1(il_jmin1+1)-dd_lat1(il_jmin1))*1.e-3
+      il_jmin0=1 ; il_jmax0=il_shape0(1)
+      il_jmin1=1 ; il_jmax1=il_shape1(1)
 
       ! check lower left fine grid
-      IF( ABS(dd_lat1(il_jmin1)-dd_lat0(il_jmin0)) > dl_dlat .AND. &
+      IF( ABS(dd_lat1(il_jmin1)-dd_lat0(il_jmin0)) > dp_delta .AND. &
       &   dd_lat1(il_jmin1) < dd_lat0(il_jmin0) )THEN
 
@@ -2353,8 +4252,6 @@
       ENDIF
 
-      dl_dlat=ABS(dd_lat1(il_jmax1-1)-dd_lat1(il_jmax1))*1.e-3
-
       ! check upper left fine grid
-      IF( ABS(dd_lat1(il_jmax1)-dd_lat0(il_jmax0)) > dl_dlat .AND. &
+      IF( ABS(dd_lat1(il_jmax1)-dd_lat0(il_jmax0)) > dp_delta .AND. &
       &   dd_lat1(il_jmax1) > dd_lat0(il_jmax0) )THEN
 
@@ -2370,5 +4267,4 @@
       
    END FUNCTION grid__check_lat
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -2376,17 +4272,14 @@
    !> 
    !> @author J.Paul
-   !> - Nov, 2013-Initial version
-   !
-   !> @param[inout] td_var : table of variable structure 
-   !> @param[in] id_ighost : i-direction ghost cell factor 
-   !> @param[in] id_jghost : j-direction ghost cell factor 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE grid_add_ghost(td_var, id_ighost, id_jghost)
+   !> - November, 2013-Initial version
+   !
+   !> @param[inout] td_var array of variable structure 
+   !> @param[in] id_ghost  array of ghost cell factor 
+   !-------------------------------------------------------------------
+   SUBROUTINE grid_add_ghost(td_var, id_ghost)
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(INOUT) :: td_var
-      INTEGER(i4), INTENT(IN   ) :: id_ighost
-      INTEGER(i4), INTENT(IN   ) :: id_jghost
+      TYPE(TVAR) ,                 INTENT(INOUT) :: td_var
+      INTEGER(i4), DIMENSION(2,2), INTENT(IN   ) :: id_ghost
 
       ! local variable
@@ -2409,18 +4302,20 @@
 
          ! copy variable
-         tl_var=td_var
+         tl_var=var_copy(td_var)
 
          CALL var_del_value(td_var)
 
          ! compute indice to fill center
-         il_imin=1+id_ighost*ig_ghost
-         il_jmin=1+id_jghost*ig_ghost
-
-         il_imax=il_imin+tl_var%t_dim(1)%i_len-1
-         il_jmax=il_jmin+tl_var%t_dim(2)%i_len-1
+         il_imin=1+id_ghost(jp_I,1)*ip_ghost
+         il_jmin=1+id_ghost(jp_J,1)*ip_ghost
+
+         il_imax=tl_var%t_dim(1)%i_len+id_ghost(jp_I,1)*ip_ghost
+         il_jmax=tl_var%t_dim(2)%i_len+id_ghost(jp_J,1)*ip_ghost
 
          ! compute new dimension
-         td_var%t_dim(1)%i_len = tl_var%t_dim(1)%i_len + 2*id_ighost*ig_ghost
-         td_var%t_dim(2)%i_len = tl_var%t_dim(2)%i_len + 2*id_jghost*ig_ghost
+         td_var%t_dim(1)%i_len = tl_var%t_dim(1)%i_len + &
+         &                             SUM(id_ghost(jp_I,:))*ip_ghost
+         td_var%t_dim(2)%i_len = tl_var%t_dim(2)%i_len + &
+         &                             SUM(id_ghost(jp_J,:))*ip_ghost
 
          ALLOCATE(dl_value(td_var%t_dim(1)%i_len, &
@@ -2448,5 +4343,4 @@
 
    END SUBROUTINE grid_add_ghost
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -2454,17 +4348,14 @@
    !> 
    !> @author J.Paul
-   !> - Nov, 2013-Initial version
-   !
-   !> @param[inout] td_var : table of variable structure 
-   !> @param[in] id_ighost : i-direction ghost cell factor 
-   !> @param[in] id_jghost : j-direction ghost cell factor 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE grid_del_ghost(td_var, id_ighost, id_jghost)
+   !> - November, 2013-Initial version
+   !
+   !> @param[inout] td_var array of variable structure 
+   !> @param[in] id_ghost  array of ghost cell factor 
+   !-------------------------------------------------------------------
+   SUBROUTINE grid_del_ghost(td_var, id_ghost)
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(INOUT) :: td_var
-      INTEGER(i4), INTENT(IN   ) :: id_ighost
-      INTEGER(i4), INTENT(IN   ) :: id_jghost
+      TYPE(TVAR) ,                 INTENT(INOUT) :: td_var
+      INTEGER(i4), DIMENSION(2,2), INTENT(IN   ) :: id_ghost
 
       ! local variable
@@ -2483,22 +4374,22 @@
       IF( ALL(td_var%t_dim(1:2)%l_use) )THEN
 
-         CALL logger_warn( "DEL GHOST: dimension change in variable "//&
+         CALL logger_warn( "GRID DEL GHOST: dimension change in variable "//&
          &              TRIM(td_var%c_name) )
 
          ! copy variable
-         tl_var=td_var
+         tl_var=var_copy(td_var)
 
          CALL var_del_value(td_var)
 
          ! compute indice to get center
-         il_imin=1+id_ighost*ig_ghost
-         il_jmin=1+id_jghost*ig_ghost
-
-         il_imax=tl_var%t_dim(1)%i_len-id_ighost*ig_ghost
-         il_jmax=tl_var%t_dim(2)%i_len-id_jghost*ig_ghost
+         il_imin=1+id_ghost(jp_I,1)*ip_ghost
+         il_jmin=1+id_ghost(jp_J,1)*ip_ghost
+
+         il_imax=tl_var%t_dim(1)%i_len-id_ghost(jp_I,2)*ip_ghost
+         il_jmax=tl_var%t_dim(2)%i_len-id_ghost(jp_J,2)*ip_ghost
 
          ! compute new dimension
-         td_var%t_dim(1)%i_len = tl_var%t_dim(1)%i_len - 2*id_ighost*ig_ghost
-         td_var%t_dim(2)%i_len = tl_var%t_dim(2)%i_len - 2*id_jghost*ig_ghost
+         td_var%t_dim(1)%i_len = il_imax - il_imin +1 
+         td_var%t_dim(2)%i_len = il_jmax - il_jmin +1 
 
          ALLOCATE(dl_value(td_var%t_dim(1)%i_len, &
@@ -2526,87 +4417,220 @@
 
    END SUBROUTINE grid_del_ghost
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill small closed sea with fill value. 
+   !-------------------------------------------------------------------
+   !> @brief This function check if ghost cell are used or not, and return ghost
+   !> cell factor (0,1) in horizontal plan.
    !
    !> @details
-   !> the minimum size (nbumber of point) of closed sea to be kept could be
-   !> sepcify with id_minsize.
-   !> By default only the biggest sea is preserve.
-   !
+   !> check if domain is global, and if there is an East-West overlap.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] id_mask : domain mask (from grid_split_domain)
-   !> @param[in] id_minsize : minimum size of sea to be kept
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE grid_fill_small_dom(td_var, id_mask, id_minsize)
+   !> - September, 2014- Initial Version
+   !
+   !> @param[in] td_var variable sturcture 
+   !> @return array of ghost cell factor
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_ghost_var( td_var )
       IMPLICIT NONE
-      ! Argument      
-      TYPE(TVAR) ,                 INTENT(INOUT) :: td_var
-      INTEGER(i4), DIMENSION(:,:), INTENT(IN   ), OPTIONAL :: id_mask
-      INTEGER(i4),                 INTENT(IN   ), OPTIONAL :: id_minsize
+      ! Argument
+      TYPE(TVAR), INTENT(IN) :: td_var
+
+      ! function
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_ghost_var
 
       ! local variable
-      INTEGER(i4)                              :: il_ndom
-      INTEGER(i4)                              :: il_minsize
-      INTEGER(i4), DIMENSION(2)                :: il_shape
-      INTEGER(i4), DIMENSION(:,:), ALLOCATABLE :: il_tmp
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
 
       ! loop indices
-      INTEGER(i4) :: ji
-      INTEGER(i4) :: jk
-      INTEGER(i4) :: jl
       !----------------------------------------------------------------
-
-      il_shape(:)=SHAPE(id_mask(:,:))
-      IF( ANY(il_shape(:) /= td_var%t_dim(1:2)%i_len) )THEN
-         CALL logger_error("GRID FILL SMALL DOM: variable and mask "//&
-         &              "dimension differ")
+      ! init
+      grid__get_ghost_var(:,:)=0
+
+      IF( .NOT. ALL(td_var%t_dim(1:2)%l_use) )THEN
+         CALL logger_error("GRID GET GHOST: "//TRIM(td_var%c_name)//" is not a suitable"//&
+         &                 " variable to look for ghost cell (not 2D).")
       ELSE
-
-         il_ndom=MINVAL(id_mask(:,:))
-
-         ALLOCATE( il_tmp(il_shape(1),il_shape(2)) )
-         il_tmp(:,:)=0
-         DO ji=-1,il_ndom,-1
-            WHERE( id_mask(:,:)==ji ) 
-               il_tmp(:,:)=SUM(id_mask(:,:),id_mask(:,:)==ji)/ji
-            END WHERE
-         ENDDO
-
-         il_minsize=MAXVAL(il_tmp(:,:))
-         IF( PRESENT(id_minsize) ) il_minsize=id_minsize
-
-         DO jl=1,td_var%t_dim(4)%i_len
-            DO jk=1,td_var%t_dim(3)%i_len
-               WHERE( il_tmp(:,:) < il_minsize ) 
-                  td_var%d_value(:,:,jk,jl)=td_var%d_fill
-               END WHERE
-            ENDDO
-         ENDDO
-
-         DEALLOCATE( il_tmp )
-
-      ENDIF
-
-   END SUBROUTINE grid_fill_small_dom
-   !> @endcode
+         IF( .NOT. ASSOCIATED(td_var%d_value) )THEN
+            CALL logger_error("GRID GET GHOST: no value associated to "//TRIM(td_var%c_name)//&
+            &                 ". can't look for ghost cell.")
+         ELSE
+            il_dim(:)=td_var%t_dim(:)%i_len
+
+            IF(ALL(td_var%d_value(    1    ,    :    ,1,1)/=td_var%d_fill).AND.&
+            &  ALL(td_var%d_value(il_dim(1),    :    ,1,1)/=td_var%d_fill).AND.&
+            &  ALL(td_var%d_value(    :    ,    1    ,1,1)/=td_var%d_fill).AND.&
+            &  ALL(td_var%d_value(    :    ,il_dim(2),1,1)/=td_var%d_fill))THEN
+            ! no boundary closed
+               CALL logger_warn("GRID GET GHOST: can't determined ghost cell. "//&
+               &             "there is no boundary closed for variable "//&
+               &              TRIM(td_var%c_name))
+
+            ELSE
+               ! check periodicity
+               IF(ANY(td_var%d_value(   1     ,:,1,1)/=td_var%d_fill).OR.&
+               &  ANY(td_var%d_value(il_dim(1),:,1,1)/=td_var%d_fill))THEN
+               ! East-West cyclic (1,4,6)
+                  CALL logger_info("GRID GET GHOST: East West cyclic")
+                  grid__get_ghost_var(jp_I,:)=0
+
+                  IF( ANY(td_var%d_value(:, 1, 1, 1) /= td_var%d_fill) )THEN
+                  ! South boundary not closed 
+
+                     CALL logger_debug("GRID GET GHOST: East_West cyclic")
+                     CALL logger_debug("GRID GET GHOST: South boundary not closed")
+                     CALL logger_error("GRID GET GHOST: should have been an "//&
+                     &              "impossible case")
+
+                  ELSE
+                  ! South boundary closed (1,4,6)
+                     CALL logger_info("GRID GET GHOST: South boundary closed")
+                     grid__get_ghost_var(jp_J,1)=1
+
+                     IF(ANY(td_var%d_value(:,il_dim(2),1,1)/=td_var%d_fill) )THEN
+                     ! North boundary not closed (4,6)
+                        CALL logger_info("GRID GET GHOST: North boundary not closed")
+                        grid__get_ghost_var(jp_J,2)=0
+                     ELSE
+                     ! North boundary closed
+                        CALL logger_info("GRID GET GHOST: North boundary closed")
+                        grid__get_ghost_var(jp_J,2)=1
+                     ENDIF
+
+                  ENDIF
+
+               ELSE
+               ! East-West boundaries closed (0,2,3,5)
+                  CALL logger_info("GRID GET GHOST: East West boundaries closed")
+                  grid__get_ghost_var(jp_I,:)=1
+
+                  IF( ANY(td_var%d_value(:, 1, 1, 1) /= td_var%d_fill) )THEN
+                  ! South boundary not closed (2)
+                     CALL logger_info("GRID GET GHOST: South boundary not closed")
+                     grid__get_ghost_var(jp_J,1)=0
+
+                     IF(ANY(td_var%d_value(:,il_dim(2),1,1)/=td_var%d_fill))THEN
+                     ! North boundary not closed
+                        CALL logger_debug("GRID GET GHOST: East West boundaries "//&
+                        &              "closed")
+                        CALL logger_debug("GRID GET GHOST: South boundary not closed")
+                        CALL logger_debug("GRID GET GHOST: North boundary not closed")
+                        CALL logger_error("GRID GET GHOST: should have been "//&
+                        &              "an impossible case")
+                     ELSE
+                     ! North boundary closed
+                        grid__get_ghost_var(jp_J,2)=1
+                     ENDIF
+
+                  ELSE
+                  ! South boundary closed (0,3,5)
+                     CALL logger_info("GRID GET GHOST: South boundary closed")
+                     grid__get_ghost_var(jp_J,1)=1
+
+                     IF(ANY(td_var%d_value(:,il_dim(2),1,1)/=td_var%d_fill))THEN
+                     ! North boundary not closed (3,5)
+                        CALL logger_info("GRID GET GHOST: North boundary not closed")
+                        grid__get_ghost_var(jp_J,2)=0
+                     ELSE
+                     ! North boundary closed   
+                        CALL logger_info("GRID GET GHOST: North boundary closed")
+                        grid__get_ghost_var(jp_J,2)=1
+                     ENDIF
+
+                  ENDIF
+
+               ENDIF
+
+            ENDIF
+
+         ENDIF
+      ENDIF
+
+   END FUNCTION grid__get_ghost_var
+   !-------------------------------------------------------------------
+   !> @brief This function check if ghost cell are used or not, and return ghost
+   !> cell factor (0,1) in i- and j-direction.
+   !
+   !> @details
+   !> get longitude an latitude array, then
+   !> check if domain is global, and if there is an East-West overlap
+   !> 
+   !> @author J.Paul
+   !> - September, 2014 - Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !
+   !> @param[in] td_file   file sturcture
+   !> @return array of ghost cell factor
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_ghost_mpp( td_mpp )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP), INTENT(IN) :: td_mpp
+
+      ! function
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_ghost_mpp
+
+      ! local variable
+      !TYPE(TVAR)  :: tl_lon
+      !TYPE(TVAR)  :: tl_lat
+
+      TYPE(TMPP) :: tl_mpp
+
+      !INTEGER(i4) :: il_lonid
+      !INTEGER(i4) :: il_latid
+      ! loop indices
+      !----------------------------------------------------------------
+      ! init
+      grid__get_ghost_mpp(:,:)=0
+
+      IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
+         CALL logger_error("GRID GET GHOST: decomposition of mpp file "//&
+         &                 TRIM(td_mpp%c_name)//" not defined." )
+
+      ELSE
+
+         ! copy structure
+          tl_mpp=mpp_copy(td_mpp)
+
+          IF( tl_mpp%i_perio < 0 )THEN
+             ! compute NEMO periodicity index
+             CALL grid_get_info(tl_mpp)
+          ENDIF
+
+         SELECT CASE(tl_mpp%i_perio)
+            CASE(0)
+               grid__get_ghost_mpp(:,:)=1
+            CASE(1)
+               grid__get_ghost_mpp(jp_J,:)=1
+            CASE(2)
+               grid__get_ghost_mpp(jp_I,:)=1
+               grid__get_ghost_mpp(jp_J,2)=1
+            CASE(3,5)
+               grid__get_ghost_mpp(jp_I,:)=1
+               grid__get_ghost_mpp(jp_J,1)=1
+            CASE(4,6)
+               grid__get_ghost_mpp(jp_J,1)=1
+            CASE DEFAULT
+         END SELECT
+
+         ! clean 
+         CALL mpp_clean(tl_mpp)
+
+      ENDIF
+
+   END FUNCTION grid__get_ghost_mpp
    !-------------------------------------------------------------------
    !> @brief This subroutine compute closed sea domain.
    !
    !> @details
-   !> to each domain is associated a negative value id (from -1 to ...)
-   !
+   !> to each domain is associated a negative value id (from -1 to ...)<br/>
+   !> optionaly you could specify which level use (default 1)
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : variable strucutre 
-   !> @param[in] id_level : level
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var    variable strucutre 
+   !> @param[in] id_level  level
    !> @return domain mask  
    !-------------------------------------------------------------------
-   !> @code
    FUNCTION grid_split_domain(td_var, id_level)
       IMPLICIT NONE
